// InfoEditWnd.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "InfoEditWnd.h"

// CInfoEditWnd
IMPLEMENT_DYNAMIC(CInfoEditWnd, CWnd)

CInfoEditWnd::CInfoEditWnd()
{
	// BG
	m_pImgBG = NULL;

	// dimension
	m_rtWnd.SetRectEmpty();
	m_rtEdit.SetRectEmpty();

	// edit
	m_crOutline = RGB(0, 128, 0);
	m_bEditMode = FALSE;

	// attribute
	m_strValue = _T("");
}

CInfoEditWnd::~CInfoEditWnd()
{
	
}

BEGIN_MESSAGE_MAP(CInfoEditWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

void CInfoEditWnd::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
	{
		strFileName = _T("Info_Edit_BG.png");
	}
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);

	//WCHAR wszImg[MAX_PATH] = L"";
	//CCommonClass::ConvertAnsiStringToWide(wszImg, strImgPath, -1);
	//m_pImgBG = new Image(wszImg);
}

void CInfoEditWnd::SetEditMode(BOOL bEdit)
{
	if (NULL == m_edit.GetSafeHwnd())
		return;

	m_bEditMode = bEdit;

	if (m_bEditMode)
	{
		m_edit.ShowWindow(SW_SHOW);
		m_edit.SetWindowText(m_strValue);
		m_edit.SetSel(0, -1);
	}
	else
	{
		m_edit.ShowWindow(SW_HIDE);
	}

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoEditWnd::SetValue(CString strValue)
{
	m_strValue = strValue;

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

// CInfoEditWnd ޽ óԴϴ.
int CInfoEditWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	int nSX = 0;
	int nSY = 0;
	int nCX = lpCreateStruct->cx;
	int nCY = lpCreateStruct->cy;
	m_rtWnd.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	if (!m_rtWnd.IsRectEmpty())
	{
		m_rtEdit = m_rtWnd;
		m_rtEdit.DeflateRect(2, 2, 2, 2);
	}

	if (!m_edit.Create(WS_CHILD | ES_AUTOHSCROLL, m_rtEdit, this, 1111))
		return -1;
	m_edit.SetFont(&g_ftDefault8PT);

	return 0;
}

BOOL CInfoEditWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CInfoEditWnd::OnPaint()
{
	CPaintDC dc(this);
	
	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	//int nWndWidth = rt.Width();
	//int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		//graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		if (m_pImgBG)
			DrawImageToDest(&graph, m_pImgBG, &rtPS, &rt, &ImgAttr);

		if (m_bEditMode)
		{
			Pen pen(Color(255, 5, 186, 33), 2);
			int nSX = m_rtWnd.left - rtPS.left;
			int nSY = m_rtWnd.top - rtPS.top;
			graph.DrawRectangle(&pen, nSX, nSY, rtPS.Width(), rtPS.Height());
		}
		else
		{
			DrawTextToDest(&graph,
						   m_strValue, &rtPS, &m_rtWnd,
						   0, 0,
						   g_defaultFontFaceName, 10,
						   StringAlignmentNear,
						   FontStyleRegular,
						   Color(255, 255, 255, 255), 3,
						   FALSE,
						   Color(255, 0, 0, 0), Color(255, 0, 0, 0));
		}

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CInfoEditWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetEditMode(TRUE);

	CWnd::OnLButtonDown(nFlags, point);
}

void CInfoEditWnd::OnLButtonUp(UINT nFlags, CPoint point)
{

	CWnd::OnLButtonUp(nFlags, point);
}

void CInfoEditWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	int nSX = 0;
	int nSY = 0;
	int nCX = cx;
	int nCY = cy;
	m_rtWnd.SetRect(0, 0, nCX, nCY);

	if (!m_rtWnd.IsRectEmpty())
	{
		m_rtEdit = m_rtWnd;
		m_rtEdit.DeflateRect(2, 2, 2, 2);

		if (m_edit.GetSafeHwnd())
			m_edit.MoveWindow(&m_rtEdit);
	}
}

BOOL CInfoEditWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	UINT notificationCode = (UINT)HIWORD(wParam);

	switch (notificationCode)
	{
	case EN_KILLFOCUS:
		{
			SetEditMode(FALSE);			
			//RedrawWindow(&m_rtImgEditOutline, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
		}
		break;
	case EN_SETFOCUS:
		{
			SetEditMode(TRUE);
			//RedrawWindow(&m_rtImgEditOutline, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
		}
		break;
	}

	return CWnd::OnCommand(wParam, lParam);
}

void CInfoEditWnd::OnDestroy()
{
	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}

	CWnd::OnDestroy();
}
